

//----------------------- USER INPUT
extern int MagicNumber = 12413;
extern double LotExponent = 1.8;//1.666667;
extern double slip = 3;
extern double pLots = 0.2;
extern double TakeProfit = 15;
extern double Stoploss =16;
extern double PipStep = 6;
extern int MaxTrades = 5;

extern bool UseStopLoss = true;
extern double TotalEquityRisk = 25; //loss as a percentage of equity

extern bool UseSafeMode = true;
extern bool UseRSIforAddTrade = false;
extern double BuyLevel = 30;
extern double SellLevel = 90;
extern double ShortLevel = 70;
extern double CoverLevel = 10;
extern int SlowPeriod = 8;
extern int FastPeriod = 5;
extern int PriceType = 5; 
bool       AllowTrading=true;
extern bool UseTrend = true;
extern int sMAPeriod = 40;
extern int MAPeriod = 10;
extern int MATimeFrame = 1440;
extern int MAMethod = 0;
extern int MAPrice = 0;

extern bool UseMASlope = false;
extern int MinPips = 10;
extern int MALookBack = 5;

extern bool UseTrailingStop = true;
extern double TrailStart = 30;
extern double TrailStop = 30;

extern bool MM = false; //Use Money Management or not
extern double RiskPercent = 0.1; //% of equity used as margin per trade

extern double    BalanceEquityProtectionLevel=0;
extern double    EquityProtectionLevel=0;

//----------------------- SETUP VARS
double PriceTarget, StartEquity, Profit, Loss, BuyTarget, SellTarget;
double AveragePrice;
double LastBuyPrice, LastSellPrice, ClosePrice, MinSpread, Spread;
int flag;
string EAName = "CostAvg-RSI-Trend v4";
datetime timeprev=0, expiration;
int NumOfTrades=0;
double iLots;
int cnt=0, total;
double Stopper=0;  
bool TradeNow = false, LongTrade=false, ShortTrade=false;
int TimeFrame = 0;
int Current = 1;
int ticket;
double MAValue, MAValue_P, sMAValue, sMAValue_P;
bool buy=false, sell=false;
bool NewOrdersPlaced = false;
double CurrentPairProfit;
double sRSI_C;
double sRSI_P;
double fRSI_C;
double fRSI_P;
bool IsClosed;
double Slope;
double MinPipMove;
double MADiff;
double CurrAvgPrice;
double Lots;
int LotDigits=2;

int init()
{
  MinSpread = MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
  Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
  MinPipMove = MinPips*Point;
  SetContinue("BalanceEquityProtectionLevel");  
  SetContinue("EquityProtectionLevel");  
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{
 Comment("Disable trading at level: " + DoubleToStr(BalanceEquityProtectionLevel*100,2),"\n","Balance -> Equity level ",DoubleToStr(AccountEquity() / AccountBalance ()* 100,2));
 if(BalanceEquityProtectionLevel > 0 && AccountEquity() <= AccountBalance ()* BalanceEquityProtectionLevel && MagicNumber == OrderMagicNumber() )
     {                         
         SendMail("Balance je dosegel Protection level!","Preveri kaj se dogaja in po potrebi naredi recompile!");         
         DisableTrading("BalanceEquityProtectionLevel");
         for(cnt=OrdersTotal();cnt>=0;cnt--)
           {                       
	          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	       int mode=OrderType();
		       if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,Blue); }
		    	 if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,Red); }			
	        }
     }   
     
   // Added Minimum Equity Level to protect from being wiped out in the event things really get wicked...more elegant risk control stuff.      
  if(EquityProtectionLevel > 0 && AccountEquity() <= EquityProtectionLevel && MagicNumber == OrderMagicNumber())
    {
      SendMail("Preseen Equity!","Preveri kaj se dogaja in po potrebi naredi recompile!");      
      DisableTrading("EquityProtectionLevel");
      for(cnt=OrdersTotal();cnt>=0;cnt--)
           {                       
	          OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	       mode=OrderType();
		       if (mode==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,Blue); }
		    	 if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,Red); }			
	        }
    }   
  
  if (CheckToContinue("EquityProtectionLevel")==0 || CheckToContinue("BalanceEquityProtectionLevel")==0 || AllowTrading==false) {return(0);}
 
 if (UseTrailingStop)   
 {
  CurrAvgPrice = CalculateCurrentAveragePrice();
  TrailingAlls(TrailStart, TrailStop, AveragePrice, CurrAvgPrice); 
 }
  
 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
  CurrentPairProfit = CalculateProfit();
  if(UseStopLoss) ActivateStop();
  
    
  sRSI_C=iRSI(Symbol(),TimeFrame,SlowPeriod,PriceType,Current);
  sRSI_P=iRSI(Symbol(),TimeFrame,SlowPeriod,PriceType,Current+1);
  fRSI_C=iRSI(Symbol(),TimeFrame,FastPeriod,PriceType,Current);
  fRSI_P=iRSI(Symbol(),TimeFrame,FastPeriod,PriceType,Current+1);


  sMAValue = iMA(Symbol(),MATimeFrame,sMAPeriod,0,MAMethod,MAPrice,Current);
  sMAValue_P = iMA(Symbol(),MATimeFrame,sMAPeriod,0,MAMethod,MAPrice,Current+MALookBack);
  MAValue = iMA(Symbol(),MATimeFrame,MAPeriod,0,MAMethod,MAPrice,Current);
  MAValue_P = iMA(Symbol(),MATimeFrame,MAPeriod,0,MAMethod,MAPrice,Current+MALookBack);
  Slope = (MAValue - MAValue_P)/MALookBack;
  MADiff = MathAbs(MAValue - MAValue_P);
  
//  Print("Slope = ", Slope);
//  Print("MADiff = ", MADiff);
  
  if(UseTrend)
  {
   if (UseMASlope)
   {
    buy = MAValue>sMAValue && Slope>0 && MADiff>MinPipMove;
    sell = MAValue<sMAValue && Slope<0 && MADiff>MinPipMove;
   } //UseMASlope
   else
   {
    buy = MAValue>sMAValue;
    sell = MAValue<sMAValue;
   } //Not UseMASlope
  } //UseTrend
  else
  {
   buy = true;
   sell = true;
  } //not UseTrend
  
  
  if (UseSafeMode)
  {
   if(sRSI_C>=SellLevel)
   {
    IsClosed = CloseLongs();
    if (IsClosed) Print("Long Closed due to RSI");  
   }
   
   if(sRSI_C<=CoverLevel)
   {
    IsClosed = CloseShorts();
    if (IsClosed) Print("Short Closed due to RSI");  
   }
   if (UseTrend)
   {
    if(sell)
    {
     IsClosed = CloseLongs();
     if (IsClosed) Print("Long Closed due to MA");  
    }
    if( buy)
    {
     IsClosed = CloseShorts();
     if (IsClosed) Print("Short Closed due to MA");  
    }
   } //UseTrend
   
  } //UseSafeMode
  

  total=CountTrades();
  if (total == 0) 
  {
    flag = 0;
    if(MM==true) 
     Lots = LotSize();
    else
     Lots = pLots;
  }
  else
   Lots = FindLots();
   
  InitializeAdditionalTrades();
  
  CheckAdditionalTradeCondition();
  
  if (total < 1) InitializeFirstTrade();
  
  if (TradeNow) PlaceAddTrade();
  if (TradeNow && total<1) PlaceFirstTrade();

  // CALCULATE AVERAGE OPENING PRICE
  AveragePrice = CalculateAverageOpeningPrice();
  
  // RECALCULATE STOPLOSS & PROFIT TARGET BASED ON AVERAGE OPENING PRICE
  ReCalculateStopAndProfitTarget();
  
  // IF NEEDED MODIFY ALL OPEN ORDERS TO NEWLY CALCULATED PROFIT TARGET    
  if(flag==1) ModifyOrders();
  

} //Start Main

int CountTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_SELL || OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}


int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_BUY:
         for(c = 0 ; c < NumberOfTries ; c++)
         {  
            RefreshRates();
            ticket=OrderSend(Symbol(),OP_BUY,pLots,Ask,sp,StopLong(Bid,sl),TakeLong(Ask,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_SELL:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELL,pLots,Bid,sp,StopShort(Ask,sl),TakeShort(Bid,tp),pComment,pMagic,pExpiration,pColor);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}

bool CloseLongs()
{
 bool Closed;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_BUY)
//    Closed = OrderClose(OrderTicket(),OrderLots(),Bid,slip,White);
    Closed = ClosePendingOrder(OP_BUY);

  }
  Sleep(1000);
  return(Closed);
 }
}

bool CloseShorts()
{
 bool Closed;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_SELL)
//    Closed = OrderClose(OrderTicket(),OrderLots(),Ask,slip,White);
    Closed = ClosePendingOrder(OP_SELL);
  }
  Sleep(1000);
  return(Closed);
 }
}

bool CloseThisSymbolAll()
{
 bool Closed;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_SELL)
//    Closed = OrderClose(OrderTicket(),OrderLots(),Ask,slip,White);
      Closed = ClosePendingOrder(OP_SELL);
   if(OrderType()==OP_BUY)
//    Closed = OrderClose(OrderTicket(),OrderLots(),Bid,slip,White);
      Closed = ClosePendingOrder(OP_BUY);
  }
  Sleep(1000);
  return(Closed);
 }
}


double CalculateProfit()
{

   double Profit=0;
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
    if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
     if(OrderType()==OP_BUY || OrderType()==OP_SELL)  
      {
       Profit=Profit+OrderProfit();
      }
   }

  return(Profit);
}

double AccountEquityHigh()
{
 static double AccountEquityHighAmt,PrevEquity;
  if(CountTrades()==0) AccountEquityHighAmt=AccountEquity();
   if(AccountEquityHighAmt < PrevEquity) AccountEquityHighAmt=PrevEquity;
   else AccountEquityHighAmt=AccountEquity();
  PrevEquity = AccountEquity();
 return(AccountEquityHighAmt);
}

double FindLastBuyPrice()
{
 double oldorderopenprice = 0, orderprice;
 int cnt, oldticketnumber = 0, ticketnumber;
 
 for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
 {
  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_BUY)  
  {
     ticketnumber = OrderTicket();
     if(ticketnumber>oldticketnumber)
     {
      orderprice=OrderOpenPrice();
      oldorderopenprice=orderprice;
      oldticketnumber=ticketnumber;
     }
  }
 }
 
  return(orderprice);
}

double FindLastSellPrice()
{
 double oldorderopenprice = 0, orderprice;
 int cnt, oldticketnumber = 0, ticketnumber;
 
 for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
 {
  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()==OP_SELL)  
  {
     ticketnumber = OrderTicket();
     if(ticketnumber>oldticketnumber)
     {
      orderprice=OrderOpenPrice();
      oldorderopenprice=orderprice;
      oldticketnumber=ticketnumber;
     }
  }
 }
 
  return(orderprice);
}

double  CalculateAverageOpeningPrice()
{
   total=CountTrades();
   double AvgPrice=0;
   double Count = 0;
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
     if(OrderType()==OP_BUY || OrderType()==OP_SELL)  
      {
       AvgPrice=AvgPrice+OrderOpenPrice()*OrderLots();
       Count = Count + OrderLots();
      }
   }
   if(total > 0)
    AvgPrice=NormalizeDouble(AvgPrice/Count, Digits);
    
   return(AvgPrice);
   
} //CalculateAverageOpeningPrice

void ReCalculateStopAndProfitTarget()
{   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
     if(OrderType()==OP_BUY) // Calculate profit/stop target for long 
     {
      PriceTarget=AveragePrice+(TakeProfit*Point);
      BuyTarget = PriceTarget;
      Stopper=AveragePrice-(Stoploss*Point); 
//      Stopper=0; 
      flag = 1;
     }
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
     if(OrderType()==OP_SELL) // Calculate profit/stop target for short
     {
      PriceTarget=AveragePrice-(TakeProfit*Point);
      SellTarget = PriceTarget;
      Stopper=AveragePrice+(Stoploss*Point);  
//      Stopper=0; 
      flag = 1; 
     }
   }
} // RecalculateStopAndProfitTarget

void ModifyOrders()
{
  if(flag==1)// check if average has really changed
  {   
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
    {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);            
     if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
      continue;
     if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      ChangeOrder(OrderTicket(),AveragePrice,OrderStopLoss(),PriceTarget,0,Yellow);// set all positions to averaged levels
    }
  }
} //ModifyOrders

void ActivateStop()
{ 

  if(CurrentPairProfit<0 && MathAbs(CurrentPairProfit)>(TotalEquityRisk/100)*AccountEquityHigh())
  {
   IsClosed = CloseThisSymbolAll();
   if (IsClosed) Print("Closed All due to Stop Out");
   NewOrdersPlaced = false;
  }
} //ActivateStop

void PlaceAddTrade()
{
   total=CountTrades();
    LastBuyPrice = FindLastBuyPrice();
    LastSellPrice = FindLastSellPrice();
   if(ShortTrade)
   {
    NumOfTrades = total;
    iLots = NormalizeDouble(Lots*MathPow(LotExponent,NumOfTrades),LotDigits);
    RefreshRates();
    ticket = OpenPendingOrder(OP_SELL,iLots,Bid,slip,Ask,0,0,EAName+"-"+NumOfTrades,MagicNumber,0,HotPink);
    if(ticket<0){Print("Error: ",GetLastError()); return(0);}
     LastSellPrice = FindLastSellPrice();
    TradeNow = false;
    NewOrdersPlaced = true;
   }
   else if (LongTrade)
   {   
    NumOfTrades = total;
    iLots = NormalizeDouble(Lots*MathPow(LotExponent,NumOfTrades),LotDigits);
    ticket = OpenPendingOrder(OP_BUY,iLots,Ask,slip,Bid,0,0,EAName+"-"+NumOfTrades,MagicNumber,0,Lime);
    if(ticket<0){Print("Error: ",GetLastError()); return(0);}
     LastBuyPrice = FindLastBuyPrice();
    TradeNow = false;
    NewOrdersPlaced = true;
   }
   
} // PlaceAddTrade

void PlaceFirstTrade()
{
   
  total=CountTrades();
   if (!ShortTrade && !LongTrade)
   {
    NumOfTrades = total;
    iLots = NormalizeDouble(Lots*MathPow(LotExponent,NumOfTrades),LotDigits);
//    if(sRSI_C>ShortLevel && sRSI_P<ShortLevel && sell)
    if(sRSI_C<ShortLevel && sRSI_P>ShortLevel && sell)
    {  
     ticket = OpenPendingOrder(OP_SELL,iLots,Bid,slip,Ask,0,0,EAName+"-"+NumOfTrades,MagicNumber,0,HotPink);
     if(ticket<0){Print("Error: ",GetLastError()); return(0);}
      LastSellPrice = FindLastSellPrice();
    }
//    if(sRSI_C<BuyLevel && sRSI_P>BuyLevel  && buy)
    if(sRSI_C>BuyLevel && sRSI_P<BuyLevel && buy)
    {  
     ticket = OpenPendingOrder(OP_BUY,iLots,Ask,slip,Bid,0,0,EAName+"-"+NumOfTrades,MagicNumber,0,Lime);
     if(ticket<0){Print("Error: ",GetLastError()); return(0);}
      LastBuyPrice = FindLastBuyPrice();
    }

    TradeNow = false;
   }
  
   
} //PlaceFirstTrade

void InitializeAdditionalTrades()
{
  for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);

    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
   
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
    if(OrderType()==OP_BUY)
    {
     LongTrade = true;
     ShortTrade = false;
     break;
    }
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
    if(OrderType()==OP_SELL)
    {
     LongTrade = false;
     ShortTrade = true;
     break;
    }
  }

} //InitializeAdditionalTrades

void InitializeFirstTrade()  
{
   ShortTrade = false;
   LongTrade = false;
   TradeNow = true;
   StartEquity = AccountEquity();
} //InitializeFirstTrade()


void CheckAdditionalTradeCondition()
{

  total=CountTrades();
    LastBuyPrice = FindLastBuyPrice();
    LastSellPrice = FindLastSellPrice();
  if(UseRSIforAddTrade)
  {
   if(total>0 && total <= MaxTrades)
   {
    RefreshRates();
    if(LongTrade)
//     if(fRSI_C<BuyLevel && fRSI_P>BuyLevel)  
//     if(fRSI_C<BuyLevel && (LastBuyPrice - Ask) >= (PipStep*Point))  
//     if(fRSI_C>BuyLevel && fRSI_P<BuyLevel)  
     if(fRSI_C>BuyLevel && fRSI_P<BuyLevel && (LastBuyPrice - Ask) >= (PipStep*Point))  
     {
      TradeNow = true;
     }
    if(ShortTrade)
//     if(fRSI_C>ShortLevel && fRSI_P<ShortLevel)  
//     if(fRSI_C>ShortLevel && (Bid- LastSellPrice) >= (PipStep*Point))  
//     if(fRSI_C<ShortLevel && fRSI_P>ShortLevel)  
     if(fRSI_C<ShortLevel && fRSI_P>ShortLevel && (Bid- LastSellPrice) >= (PipStep*Point))  
     {
      TradeNow = true;
     }
   } 
  }
  else
  {
   if(total>0 && total <= MaxTrades)
   {
    RefreshRates();
    if(LongTrade && (LastBuyPrice - Ask) >= (PipStep*Point))
     {
      TradeNow = true;
     }
    if(ShortTrade && (Bid- LastSellPrice) >= (PipStep*Point))
     {
      TradeNow = true;
     }
   } 
  }
  
} //CheckAdditionalTrade 

bool ClosePendingOrder(int pType)
{
  int err=0;
  int c = 0;
  int trade;
  int NumberOfTries = 100;
  bool tradeclosed;
   
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
    OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      
    if(OrderSymbol()!=Symbol())
      continue;
    if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
    {
     switch (pType)
     {
      case OP_SELL:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            RefreshRates();
            tradeclosed = OrderClose(OrderTicket(),OrderLots(),Ask,slip,White);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } //for c   
      break; //OpSell
      
      case OP_BUY:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            RefreshRates();
            tradeclosed = OrderClose(OrderTicket(),OrderLots(),Bid,slip,White);
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } //for c   
      break; //OpBuy
      
     }//switch
    } //if OrderSymbol()=Symbol() 
   } //for
  
  return(tradeclosed);
}  

bool ChangeOrder(int Ticket, double OpenPrice, double sp, double tp, datetime pExpiration, color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  bool Success=false;
  
  for(c = 0 ; c < NumberOfTries ; c++)
  {
   Success=OrderModify(Ticket, OpenPrice, sp, tp, pExpiration, pColor);
   err=GetLastError();
   if(err==0)
   { 
    break;
   }
   else
   {
    if(err==4 || err==137 ||err==146 || err==136) //Busy errors
    {
     Sleep(5000);
     continue;
    }
    else //normal error
    {
     break;
    }  
   }
  }   

  return(0);
}  

void TrailingAlls(int start,int stop, double AvgPrice, double CurAvg)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderSymbol()==Symbol()||OrderMagicNumber()==MagicNumber)
  {
   if(OrderType()==OP_BUY)
   {
//    profit=NormalizeDouble((AvgPrice-CurAvg)/Point,0);
    profit=NormalizeDouble((CurAvg - AvgPrice)/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=CurAvg-(stop*Point);
    if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
     OrderModify(OrderTicket(),AvgPrice,stopcal,OrderTakeProfit(),0,Aqua);
   }//Long
  
   if(OrderType()==OP_SELL)
   {
//    profit=NormalizeDouble((CurAvg - AvgPrice)/Point,0);
    profit=NormalizeDouble((AvgPrice-CurAvg)/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=CurAvg+(stop*Point)+Spread;
    if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
     OrderModify(OrderTicket(),AvgPrice,stopcal,OrderTakeProfit(),0,Red);
   }//Shrt
  }
  Sleep(1000);
 }//for
}

double  CalculateCurrentAveragePrice()
{
   total=CountTrades();
   double AvgPrice=0;
   double Count = 0;
   for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
     if(OrderType()==OP_BUY)  
      {
       AvgPrice=AvgPrice+Ask*OrderLots();
       Count = Count + OrderLots();
      }
     if(OrderType()==OP_SELL)  
      {
       AvgPrice=AvgPrice+Bid*OrderLots();
       Count = Count + OrderLots();
      }
   }
   if(total > 0)
    AvgPrice=NormalizeDouble(AvgPrice/Count, Digits);
    
   return(AvgPrice);
   
} //CalculateCurrentAveragePrice

double LotSize()
{ 
 int Leverage =  AccountLeverage(); 
 double lotMM;

 lotMM = NormalizeDouble(AccountFreeMargin()*(RiskPercent/100)/(Leverage),1);
   
   if (lotMM < 0.1) lotMM = pLots;
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
}

double FindLots()
{
  double MinLots = 1000000000, LotSize;
  for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);

    if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
     continue;
   
    if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
    {
     LotSize = OrderLots();
     if(LotSize < MinLots) MinLots = LotSize;
    }
   Print("MinLots=",MinLots);
  }

 return (MinLots);
}
int CheckToContinue(string FileName)
{
string str;     
  int handle=FileOpen(FileName+".csv",FILE_CSV|FILE_READ);
  if (handle > 0)
    {
      str = FileReadString(handle);
      FileClose(handle);
        if (str=="false") 
          {
            Print ("Nadalnje trgovanje za par " + Symbol()+ " je onemogoeno! Prosim ponovno zaeni recompile skripte!"); 
            return(0);        
          }    
    }
    return(1);   
}
void SetContinue(string FileName)
{
  int handle;
  handle=FileOpen(FileName+".csv", FILE_CSV|FILE_WRITE); 
  if(handle>0)
    {
      FileWrite(handle, "true");
      FileClose(handle);
    } 
}
void DisableTrading(string FileName)
{
  int handle;
  handle=FileOpen(FileName+".csv", FILE_CSV|FILE_WRITE); 
  if(handle>0)
    {
      FileWrite(handle, "false");
      FileClose(handle);
    }
}

